clear 
clc
%% DATA INPUT

%CALIBRATION LOAD
%Map of calibration of the microphones' signals with a Bruel & Keajer
%high-quality microphone. The maps are obtained in two groups, merged on
%one matrix G2.
load('primo_grup.mat')  %restituisce G1  << contiene i primi 8 coefficienti
load('secondo_grup.mat')%restituisce G2 << contiene i successivi 8 coefficienti

% non so perchè non li abbiano salvati in una unica variabile.. (?)

G2(:,1:8)=G1; %Microphones' calibration matrix
%----------------

%DATA LOAD
FileTDMS = TDMS_readTDMSFile(filename_tdms)

%CALIBRATION OF SIGNALS
for i=1:16
    MicRawMean(i)=mean(MicRaw(:,i));
    MicRawFluctuation(:,i) = MicRaw(:,i) - MicRawMean(i);
    MicCalibrated(:,i) = filter(G2(:,i),1, MicRawFluctuationFiltered(:,i));%Calibration of the microphones' signals with the calibration matrix G2
    MicPressure(i,:)= MicCalibrated(:,i)*10; % [Pa] Bruel & Kjaer reference microphone sensibility = 100[mV/Pa]
end


% prende la media del segnale, la sottrae al segnale
% filtra con finestra di filtro G2(:,i)
% moltiplica x 10 